# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_04_01_preview
  module Models
    #
    # Information about the azure function destination for an event
    # subscription.
    #
    class AzureFunctionEventSubscriptionDestination < EventSubscriptionDestination

      include MsRestAzure


      def initialize
        @endpointType = "AzureFunction"
      end

      attr_accessor :endpointType

      # @return [String] The Azure Resource Id that represents the endpoint of
      # the Azure Function destination of an event subscription.
      attr_accessor :resource_id

      # @return [Integer] Maximum number of events per batch.
      attr_accessor :max_events_per_batch

      # @return [Integer] Preferred batch size in Kilobytes.
      attr_accessor :preferred_batch_size_in_kilobytes


      #
      # Mapper for AzureFunctionEventSubscriptionDestination class as Ruby
      # Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AzureFunction',
          type: {
            name: 'Composite',
            class_name: 'AzureFunctionEventSubscriptionDestination',
            model_properties: {
              endpointType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'endpointType',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.resourceId',
                type: {
                  name: 'String'
                }
              },
              max_events_per_batch: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.maxEventsPerBatch',
                type: {
                  name: 'Number'
                }
              },
              preferred_batch_size_in_kilobytes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.preferredBatchSizeInKilobytes',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
