# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_04_01_preview
  module Models
    #
    # Information about a partner registration.
    #
    class PartnerRegistration < TrackedResource

      include MsRestAzure

      # @return [PartnerRegistrationProvisioningState] Provisioning state of
      # the partner registration. Possible values include: 'Creating',
      # 'Updating', 'Deleting', 'Succeeded', 'Canceled', 'Failed'
      attr_accessor :provisioning_state

      # @return [String] Official name of the partner name. For example:
      # "Contoso".
      attr_accessor :partner_name

      # @return [String] Name of the partner resource type.
      attr_accessor :partner_resource_type_name

      # @return [String] Display name of the partner resource type.
      attr_accessor :partner_resource_type_display_name

      # @return [String] Short description of the partner resource type. The
      # length of this description should not exceed 256 characters.
      attr_accessor :partner_resource_type_description

      # @return [String] Long description for the custom scenarios and
      # integration to be displayed in the portal if needed.
      # Length of this description should not exceed 2048 characters.
      attr_accessor :long_description

      # @return [String] The customer service number of the publisher. The
      # expected phone format should start with a '+' sign
      # followed by the country code. The remaining digits are then followed.
      # Only digits and spaces are allowed and its
      # length cannot exceed 16 digits including country code. Examples of
      # valid phone numbers are: +1 515 123 4567 and
      # +966 7 5115 2471. Examples of invalid phone numbers are: +1 (515)
      # 123-4567, 1 515 123 4567 and +966 121 5115 24 7 551 1234 43
      attr_accessor :partner_customer_service_number

      # @return [String] The extension of the customer service number of the
      # publisher. Only digits are allowed and number of digits should not
      # exceed 10.
      attr_accessor :partner_customer_service_extension

      # @return [String] The extension of the customer service URI of the
      # publisher.
      attr_accessor :customer_service_uri

      # @return [String] URI of the partner website that can be used by Azure
      # customers to setup Event Grid
      # integration on an event source.
      attr_accessor :setup_uri

      # @return [String] URI of the logo.
      attr_accessor :logo_uri

      # @return [PartnerRegistrationVisibilityState] Visibility state of the
      # partner registration. Possible values include: 'Hidden',
      # 'PublicPreview', 'GenerallyAvailable'
      attr_accessor :visibility_state

      # @return [Array<String>] List of Azure subscription Ids that are
      # authorized to create a partner namespace
      # associated with this partner registration. This is an optional
      # property. Creating
      # partner namespaces is always permitted under the same Azure
      # subscription as the one used
      # for creating the partner registration.
      attr_accessor :authorized_azure_subscription_ids


      #
      # Mapper for PartnerRegistration class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PartnerRegistration',
          type: {
            name: 'Composite',
            class_name: 'PartnerRegistration',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              partner_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerName',
                type: {
                  name: 'String'
                }
              },
              partner_resource_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerResourceTypeName',
                type: {
                  name: 'String'
                }
              },
              partner_resource_type_display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerResourceTypeDisplayName',
                type: {
                  name: 'String'
                }
              },
              partner_resource_type_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerResourceTypeDescription',
                type: {
                  name: 'String'
                }
              },
              long_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.longDescription',
                type: {
                  name: 'String'
                }
              },
              partner_customer_service_number: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerCustomerServiceNumber',
                type: {
                  name: 'String'
                }
              },
              partner_customer_service_extension: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.partnerCustomerServiceExtension',
                type: {
                  name: 'String'
                }
              },
              customer_service_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.customerServiceUri',
                type: {
                  name: 'String'
                }
              },
              setup_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.setupUri',
                type: {
                  name: 'String'
                }
              },
              logo_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.logoUri',
                type: {
                  name: 'String'
                }
              },
              visibility_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.visibilityState',
                type: {
                  name: 'String'
                }
              },
              authorized_azure_subscription_ids: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.authorizedAzureSubscriptionIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
