# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_10_15_preview
  module Models
    #
    # Properties of the Partner Registration update.
    #
    class PartnerRegistrationUpdateParameters

      include MsRestAzure

      # @return [Hash{String => String}] Tags of the partner registration
      # resource.
      attr_accessor :tags

      # @return [String] Name of the partner topic type.
      attr_accessor :partner_topic_type_name

      # @return [String] Display name of the partner topic type.
      attr_accessor :partner_topic_type_display_name

      # @return [String] Description of the partner topic type.
      attr_accessor :partner_topic_type_description

      # @return [String] URI of the partner website that can be used by Azure
      # customers to setup Event Grid
      # integration on an event source.
      attr_accessor :setup_uri

      # @return [String] URI of the partner logo.
      attr_accessor :logo_uri

      # @return [Array<String>] List of IDs of Azure AD applications that are
      # authorized to create a partner namespace
      # associated with this partner registration. This is an optional
      # property. Creating
      # partner namespaces is always permitted under the same Azure
      # subscription as the one used
      # for creating the partner registration.
      attr_accessor :authorized_azure_subscription_ids


      #
      # Mapper for PartnerRegistrationUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PartnerRegistrationUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'PartnerRegistrationUpdateParameters',
            model_properties: {
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              partner_topic_type_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partnerTopicTypeName',
                type: {
                  name: 'String'
                }
              },
              partner_topic_type_display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partnerTopicTypeDisplayName',
                type: {
                  name: 'String'
                }
              },
              partner_topic_type_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'partnerTopicTypeDescription',
                type: {
                  name: 'String'
                }
              },
              setup_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'setupUri',
                type: {
                  name: 'String'
                }
              },
              logo_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'logoUri',
                type: {
                  name: 'String'
                }
              },
              authorized_azure_subscription_ids: {
                client_side_validation: true,
                required: false,
                serialized_name: 'authorizedAzureSubscriptionIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
