# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EventGrid::Mgmt::V2020_10_15_preview
  module Models
    #
    # EventGrid Topic
    #
    class Topic < TrackedResource

      include MsRestAzure

      # @return [Array<PrivateEndpointConnection>]
      attr_accessor :private_endpoint_connections

      # @return [TopicProvisioningState] Provisioning state of the topic.
      # Possible values include: 'Creating', 'Updating', 'Deleting',
      # 'Succeeded', 'Canceled', 'Failed'
      attr_accessor :provisioning_state

      # @return [String] Endpoint for the topic.
      attr_accessor :endpoint

      # @return [InputSchema] This determines the format that Event Grid should
      # expect for incoming events published to the topic. Possible values
      # include: 'EventGridSchema', 'CustomEventSchema',
      # 'CloudEventSchemaV1_0'. Default value: 'EventGridSchema' .
      attr_accessor :input_schema

      # @return [InputSchemaMapping] This enables publishing using custom event
      # schemas. An InputSchemaMapping can be specified to map various
      # properties of a source schema to various required properties of the
      # EventGridEvent schema.
      attr_accessor :input_schema_mapping

      # @return [String] Metric resource id for the topic.
      attr_accessor :metric_resource_id

      # @return [PublicNetworkAccess] This determines if traffic is allowed
      # over public network. By default it is enabled.
      # You can further restrict to specific IPs by configuring <seealso
      # cref="P:Microsoft.Azure.Events.ResourceProvider.Common.Contracts.TopicProperties.InboundIpRules"
      # />. Possible values include: 'Enabled', 'Disabled'. Default value:
      # 'Enabled' .
      attr_accessor :public_network_access

      # @return [Array<InboundIpRule>] This can be used to restrict traffic
      # from specific IPs instead of all IPs. Note: These are considered only
      # if PublicNetworkAccess is enabled.
      attr_accessor :inbound_ip_rules

      # @return [ResourceSku] The Sku pricing tier for the topic. Default
      # value: Basic .
      attr_accessor :sku

      # @return [IdentityInfo] Identity information for the resource.
      attr_accessor :identity

      # @return [ResourceKind] Kind of the resource. Possible values include:
      # 'Azure', 'AzureArc'
      attr_accessor :kind

      # @return [ExtendedLocation] Extended location of the resource.
      attr_accessor :extended_location

      # @return [SystemData] The system metadata relating to Topic resource.
      attr_accessor :system_data


      #
      # Mapper for Topic class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Topic',
          type: {
            name: 'Composite',
            class_name: 'Topic',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: true,
                serialized_name: 'location',
                type: {
                  name: 'String'
                }
              },
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              private_endpoint_connections: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.privateEndpointConnections',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'PrivateEndpointConnectionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'PrivateEndpointConnection'
                      }
                  }
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.provisioningState',
                type: {
                  name: 'String'
                }
              },
              endpoint: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.endpoint',
                type: {
                  name: 'String'
                }
              },
              input_schema: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.inputSchema',
                default_value: 'EventGridSchema',
                type: {
                  name: 'String'
                }
              },
              input_schema_mapping: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.inputSchemaMapping',
                type: {
                  name: 'Composite',
                  polymorphic_discriminator: 'inputSchemaMappingType',
                  uber_parent: 'InputSchemaMapping',
                  class_name: 'InputSchemaMapping'
                }
              },
              metric_resource_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.metricResourceId',
                type: {
                  name: 'String'
                }
              },
              public_network_access: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.publicNetworkAccess',
                default_value: 'Enabled',
                type: {
                  name: 'String'
                }
              },
              inbound_ip_rules: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.inboundIpRules',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'InboundIpRuleElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'InboundIpRule'
                      }
                  }
                }
              },
              sku: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sku',
                default_value: Basic,
                type: {
                  name: 'Composite',
                  class_name: 'ResourceSku'
                }
              },
              identity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'identity',
                type: {
                  name: 'Composite',
                  class_name: 'IdentityInfo'
                }
              },
              kind: {
                client_side_validation: true,
                required: false,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              extended_location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'extendedLocation',
                type: {
                  name: 'Composite',
                  class_name: 'ExtendedLocation'
                }
              },
              system_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'systemData',
                type: {
                  name: 'Composite',
                  class_name: 'SystemData'
                }
              }
            }
          }
        }
      end
    end
  end
end
